# initialize objective and set this value to 1
scoreboard objectives add temp dummy
scoreboard players set @s temp 1

# if entity is in a non-solid block, set this to 0
execute @s ~ ~ ~ detect ~ ~ ~ air 0 scoreboard players set @s temp 0
execute @s ~ ~ ~ detect ~ ~ ~ light_block -1 scoreboard players set @s temp 0

# if entity is not on ground, set this to -1
execute @s[scores={temp=0}] ~ ~ ~ detect ~ ~-1 ~ air 0 scoreboard players set @s temp -1
execute @s[scores={temp=0}] ~ ~ ~ detect ~ ~-1 ~ light_block -1 scoreboard players set @s temp -1

# else teleport entity up half a block
tp @s[scores={temp=1}] ~ ~0.5 ~

# if entity is at or above sky limit, teleport entity to y=1
tp @s[scores={temp=1},y=256,dy=5] ~ 1 ~

# if entity is not on ground, teleport down half a block
tp @s[scores={temp=-1}] ~ -0.5 ~

# if entity is in solid block or not on ground, repeat function
execute @s[scores={temp=1}] ~ ~ ~ function common/to_surface
execute @s[scores={temp=-1}] ~ ~ ~ function common/to_surface

# if entity is in non-solid block, remove score from them
execute @s[scores={temp=0}] ~ ~ ~ scoreboard players reset @s temp